package command

import (
	"gitlab.schukai.com/oss/utilities/conan/configuration"
	"gitlab.schukai.com/oss/utilities/conan/logging"
	"gitlab.schukai.com/oss/utilities/conan/server"
)

type ServerServeCommand struct {
	Port    string `long:"port" short:"p" description:"Port to listen on"`
	Address string `long:"address" short:"a" description:"Address to serve on"`
	WebPath string `long:"web-path" short:"w" description:"Path to web files"`
}

func (r *ServerServeCommand) execute() {

	configuration.SetServerPort(r.Port)
	configuration.SetServerAddress(r.Address)
	configuration.SetServerWebPath(r.WebPath)

	logging.InitLogger()

	server.Start()

}
