package command

import "github.com/jessevdk/go-flags"

type CommandsStruct struct {
	ConfigPath string         `long:"config" short:"c" description:"Path to configuration file"`
	Release    ReleaseCommand `command:"release" alias:"r" description:"Release commands"`
	Server     ServerCommand  `command:"server" alias:"s" description:"Start server and listen for requests"`
}

type commandsStruct struct {
	parser     *flags.Parser
	definition *CommandsStruct
	handler    map[string]handler
}

var cmdInst *commandsStruct

func init() {
	cmdInst = &commandsStruct{}
	cmdInst.definition = &CommandsStruct{}
	cmdInst.handler = make(map[string]handler)

	registerCommandHandler("release-print", &cmdInst.definition.Release.Print)
	registerCommandHandler("server-serve", &cmdInst.definition.Server.Serve)
}

func registerCommandHandler(name string, handler handler) {
	cmdInst.handler[name] = handler
}
