package configuration

import (
	error2 "gitlab.schukai.com/oss/utilities/conan/error"
	"net/url"
	"strconv"
)

func GetConfigurationPath() string {
	return configurationPath
}

func GetWatch() []Watch {
	return configurationInstance.Server.Watch
}

func GetServerFlagFollowSymlinks() bool {
	return configurationInstance.Server.Flags.FollowSymlinks
}

func GetServerLoglevel() string {
	return configurationInstance.Server.Logging.Level
}

func GetClientMessagesEndpointPath() string {
	u, err := url.ParseRequestURI(configurationInstance.Client.Endpoints.Messages)
	error2.CheckError(err)
	return u.Path
}

func GetClientMessagesEndpoint() string {
	return configurationInstance.Client.Endpoints.Messages
}

func SetServerPort(port string) {

	if port == "" {
		return
	}

	p, err := strconv.Atoi(port)
	error2.CheckError(err)
	configurationInstance.Server.Port = p
}

func SetServerHost(host string) {

	if host == "" {
		return
	}

	configurationInstance.Server.Host = host
}
func SetServerAddress(address string) {

	if address == "" {
		return
	}

	configurationInstance.Server.Address = address
}

func SetServerWebPath(path string) {

	if path == "" {
		return
	}

	configurationInstance.Server.Path.Web = path
}

func GetServerPort() string {
	return strconv.FormatInt(int64(configurationInstance.Server.Port), 10)
}

func GetServerAddress() string {
	return configurationInstance.Server.Address
}

func GetServerHost() string {
	return configurationInstance.Server.Host
}

func GetServerWebPath() string {
	return getAbsolutePath(configurationInstance.Server.Path.Web)
}

func GetServerSourcePath() string {
	return getAbsolutePath(configurationInstance.Server.Path.Source)
}

func IsResourcePathSet() bool {
	return configurationInstance.Server.Path.Resource != ""
}

func GetResourcePath() string {
	return getAbsolutePath(configurationInstance.Server.Path.Resource)
}
