package configuration

import (
	error2 "gitlab.schukai.com/oss/utilities/conan/error"
	"net/url"
	"path"
	"strconv"
)

func sanitizeMessageEndpoint() {
	e := configurationInstance.Client.Endpoints.Messages

	u, err := url.ParseRequestURI(e)
	error2.CheckError(err)

	if u.Scheme != "ws" {
		u.Scheme = "ws"
	}

	if u.Host == "" {

		u.Host = configurationInstance.Server.Host
		if u.Host == "" {
			error2.PrintErrorAndExit("Host not set")
		}
	}

	configurationInstance.Client.Endpoints.Messages = u.String()

}

func sanitizeSerer() {

	if configurationInstance.Server.Address == "localhost" {
		configurationInstance.Server.Address = "127.0.0.1"
	}

	if configurationInstance.Server.Port == 0 {
		configurationInstance.Server.Port = 8080
	}

	if configurationInstance.Server.Host == "" {
		configurationInstance.Server.Host = "127.0.0.1:" + strconv.Itoa(configurationInstance.Server.Port)
	}

}

func sanitizeWatch() {
	for i := range configurationInstance.Server.Watch {
		if configurationInstance.Server.Watch[i].Path == "." {
			configurationInstance.Server.Watch[i].Path = GetConfigurationPath()
			continue
		}

		if configurationInstance.Server.Watch[i].Path == "" {
			continue
		}

		if !path.IsAbs(configurationInstance.Server.Watch[i].Path) {
			configurationInstance.Server.Watch[i].Path = path.Join(GetConfigurationPath(), configurationInstance.Server.Watch[i].Path)
		}
	}
}

func sanitize() {
	sanitizeSerer()
	sanitizeWatch()
	sanitizeMessageEndpoint()
}
