package error

import (
	"github.com/gookit/color"
	"os"
)

func CheckError(err error) {
	if err != nil {
		PrintErrorAndExit(err.Error())
	}

}

func Exit(code int) {
	os.Exit(code)
}

var lastBlock string

func PrintErrorAndExit(message string, a ...interface{}) {
	PrintError(message, a...)
	os.Exit(1)
}

func PrintError(message string, a ...interface{}) {

	if lastBlock == "error" {
		color.Error.Println("\t"+message, a)
		return
	}

	lastBlock = "error"
	color.Error.Block(message, a...)

}

func PrintWarning(message string, a ...interface{}) {

	if lastBlock == "warning" {
		color.Warn.Println("\t"+message, a)
		return
	}

	lastBlock = "warning"
	color.Warn.Block(message, a...)
}
