package error

import (
	"errors"
)

var (

	// ErrNotFound is the error returned when a resource is not found.
	ErrNotFound = errors.New("not found")
	// ErrAlreadyExists is the error returned when a resource already exists.
	ErrAlreadyExists = errors.New("already exists")
	// ErrInvalidArgument is the error returned when an invalid argument is provided.
	ErrInvalidArgument = errors.New("invalid argument")
	// ErrInvalidState is the error returned when an operation is not allowed in the current state.
	ErrInvalidState = errors.New("invalid state")
	// ErrNotImplemented is the error returned when an operation is not implemented.
	ErrNotImplemented = errors.New("not implemented")
	// ErrTimeout is the error returned when an operation times out.
	ErrTimeout = errors.New("timeout")
	// ErrCanceled is the error returned when an operation is canceled.
	ErrCanceled = errors.New("canceled")
	// ErrUnauthorized is the error returned when an operation is unauthorized.
	ErrUnauthorized = errors.New("unauthorized")
	// ErrForbidden is the error returned when an operation is forbidden.
	ErrForbidden = errors.New("forbidden")
	// ErrFailedPrecondition is the error returned when an operation failed precondition.
	ErrFailedPrecondition = errors.New("failed precondition")
	// ErrAborted is the error returned when an operation is aborted.
	ErrAborted = errors.New("aborted")
	// ErrOutOfRange is the error returned when an operation is out of range.
	ErrOutOfRange = errors.New("out of range")
	// ErrUnavailable is the error returned when an operation is unavailable.
	ErrUnavailable = errors.New("unavailable")
	// ErrDataLoss is the error returned when data is lost.
	ErrDataLoss = errors.New("data loss")
	// ErrUnauthenticated is the error returned when an operation is unauthenticated.
	ErrUnauthenticated = errors.New("unauthenticated")
)
