package server

import (
	"gitlab.schukai.com/oss/utilities/conan/configuration"
	error2 "gitlab.schukai.com/oss/utilities/conan/error"
	"gitlab.schukai.com/oss/utilities/conan/logging"
	"gitlab.schukai.com/oss/utilities/conan/watch"
	"net/http"
)

func Start() {

	address := configuration.GetServerAddress() + ":" + configuration.GetServerPort()

	server := http.Server{
		Handler: getRouter(),
		Addr:    address,
	}

	watch.InitWatch()

	logging.LogInfo("Server started on %s", address)
	logging.LogInfo("Web path: %s", configuration.GetServerWebPath())
	logging.LogInfo("Available at (non-exhaustive list): %s", "http://"+configuration.GetServerHost()+"/")
	logging.LogInfo("Press %s to quit.", "Ctrl+C")

	watch.StartWatching()
	err := server.ListenAndServe()
	error2.CheckError(err)

	watch.DestroyApps()

}
