#############################################################################################
#############################################################################################
##
## COMMANDS NODEJS
##
#############################################################################################
#############################################################################################

# path and binaries
NODEJS            ?= node
NODE              ?= node
NPM               ?= pnpm

EXECUTABLES = $(EXECUTABLES:-) $(PNPM); 

NODE_PACKAGES := $(shell find $(PROJECT_ROOT) -type f -name 'package.json' -not -path '*/node_modules/*')
NODE_MODULES := $(shell find $(PROJECT_ROOT) -type d -name 'node_modules' -prune)
NODE_MODULES_MODIFIED := $(shell find $(PROJECT_ROOT) -type d -name 'node_modules' -prune -exec echo {}/.modified \;  )

$(NODE_MODULES_MODIFIED): $(NODE_PACKAGES)
	$(ECHOMARKER) "Updating node modules..."
	$(QUIET) for p in $(NODE_PACKAGES); do \
  		DIR=$$(dirname $$p); \
		echo "Updating package: $${DIR}" ;\
		$(NPM) install --prefix $${DIR}  ;\
	done ; \
	touch $(NODE_MODULES_MODIFIED)
 
## Main Develpoment Node Repos 
NODE_ROOT_DIR          ?= $(DEVELOPMENT_PATH)
NODE_MODULES_DIR       ?= $(NODE_ROOT_DIR)node_modules/
NODE_PACKAGE_PATH      ?= $(NODE_ROOT_DIR)package.json
NODE_MODULES_BIN_DIR   ?= $(NODE_MODULES_DIR).bin/

ESBUILD       ?= $(NODE_MODULES_BIN_DIR)esbuild
WEBPACK       ?= $(NODE_MODULES_BIN_DIR)webpack
BABEL         ?= $(NODE_MODULES_BIN_DIR)babel
UGLIFYJS      ?= $(NODE_MODULES_BIN_DIR)uglifyjs
C8            ?= $(NODE_MODULES_BIN_DIR)c8
MOCHA         ?= $(NODE_MODULES_BIN_DIR)mocha

PACKAGE_JSON ?= $(NODE_ROOT_DIR)package.json

MJS_SOURCE_FILES                       := $(shell find $(SOURCE_PATH) -name '*.mjs')
MJS_RELATIVE_SOURCE_FILES              := $(shell find $(SOURCE_PATH) -name '*.mjs' -exec realpath --relative-to $(PROJECT_ROOT) {} \;   )

JS_SOURCE_FILES                       := $(shell find $(SOURCE_PATH) -name '*.js')
JS_RELATIVE_SOURCE_FILES              := $(shell find $(SOURCE_PATH) -name '*.js' -exec realpath --relative-to $(PROJECT_ROOT) {} \;   )



