
#############################################################################################
#############################################################################################
##
## DOCMAN-TARGETS
##
#############################################################################################
#############################################################################################



$(PROJECT_ROOT)deployment/build/manual.html: ~/.local/bin/docman
	docman document html --config $(PROJECT_ROOT)documentation/config.yaml

$(PROJECT_ROOT)deployment/build/manual.pdf: ~/.local/bin/docman
	docman document pdf --config $(PROJECT_ROOT)documentation/config.yaml

.PHONY: build-doc-pdf
## creating the documentation in pdf format
build-doc-pdf: $(PROJECT_ROOT)deployment/build/manual.pdf

.PHONY: build-doc-html
## creating the documentation in html format
build-doc-html: $(PROJECT_ROOT)deployment/build/manual.html


.PHONY: build-doc
## creating the documentation in pdf and html format
build-doc: build-doc-pdf build-doc-html


~/.local/bin/docman:
	wget -O ~/.local/bin/docman https://download.schukai.com/tools/docman/docman-linux-amd64
	chmod u+x ~/.local/bin/docman


.PHONY: install-docman
install-docman: ~/.local/bin/docman

