#############################################################################################
#############################################################################################
##
## VERSIONS
##
#############################################################################################
#############################################################################################

VERSION_BIN 	     := version
EXECUTABLES = $(EXECUTABLES:-) $(VERSION_BIN)

RELEASE_FILE ?= $(PROJECT_ROOT)release.json
 
ifeq ("$(wildcard $(RELEASE_FILE))","")
  $(shell echo '{"version":"0.1.0"}' > $(RELEASE_FILE))
endif

PROJECT_VERSION ?= $(shell cat $(RELEASE_FILE) | jq -r .version)
PROJECT_BUILD_DATE ?= $(shell $(VERSION_BIN) date)

.PHONY: next-patch-version
## create next patch version
next-patch-version:
	$(ECHOMARKER) "Creating next version"
	$(QUIET) $(VERSION_BIN) patch --path $(RELEASE_FILE) --selector "version"
	$(QUIET) $(eval PROJECT_VERSION := $(shell cat $(RELEASE_FILE) | jq -r .version))

.PHONY: next-minor-version
## create next minor version
next-minor-version:
	$(ECHOMARKER) "Creating next minor version"
	$(QUIET) $(VERSION_BIN) minor --path $(RELEASE_FILE) --selector "version"
	$(QUIET) $(eval PROJECT_VERSION := $(shell cat $(RELEASE_FILE) | jq -r .version))

.PHONY: next-major-version
## create next major version
next-major-version:
	$(ECHOMARKER) "Creating next minor version"
	$(QUIET) $(VERSION_BIN) major --path $(RELEASE_FILE) --selector "version"
	$(QUIET) $(eval PROJECT_VERSION := $(shell cat $(RELEASE_FILE) | jq -r .version))
